// Inheritance1_specialisation.cpp
// Example for inheritance used for specialization
// M. Schukat, 2002

// include header files
#include <iostream.h>
#include <string.h>


// Parent class Muppet
class Muppet
{
private:
	char name[20];

protected:
	char greeting[20];

public:
	// Constructor
	Muppet(void)
	{
		strcpy(greeting, "Nice to meet you.");
	}

	// member function assignName
	void assignName(char *s)
	{
		strcpy(name, s);
	}
	
	// Member function greet
	void greet(void)
	{
		cout << "This is " << name << ". He says: " << greeting << endl << endl;
	}
};


// Derived class GrumpyMuppet
class GrumpyMuppet : public Muppet
{
public:
	// New constructor
	GrumpyMuppet(void)
	{
		strcpy(greeting, "Go away!!");
	}
};

// Main function
int main(void)
{
	Muppet kermit;
	GrumpyMuppet oscar;

	kermit.assignName("Kermit the Frog");
	oscar.assignName("Oscar the Grouch");

	kermit.greet();
	oscar.greet();
	
	return 0;
}
