// reffun.cpp: Reference as return value will be l-value.
// M. Schukat, 2002
// Based on:
//    Ammeraal, L. (2000) C++ for Programmers, 3rd Ed., Chichester: Wiley,
//    p. 106.

#include <iostream.h>

// Function prototypes
int &maxim(int& x, int& y);


int main()
{  
	int a = 23, b = 15;

	cout << "a = " << a << "  b = " << b << endl;
   
	// First call to maxim:
	cout << "The larger of these is " << maxim(a, b) << endl;

	// Second call to maxim:
	maxim(a, b) = 0;  // A function call as left-hand side!

	cout << "The larger of a and b is set to 0. Thus we now have \n";
	cout << "a = " << a << "  b = " << b << endl;

	return 0;
}


// Implementation of int &maxim(int& x, int& y)
int &maxim(int& x, int& y)
{  
	return (x > y ? x : y);
}
