// List.h
// M. Schukat, 2002
 
// Declaration of structure for element:
struct DoubElem
{	
	double element;
	DoubElem* next;
};


// Declaration of class for set:
class DoubSet
{
public:
	DoubSet(void) 
	{
		number = 0; 
	 	start  = 0;
	}

	// Modification 1:
	// Constructor can be replaced with
	// DoubSet(void) : number(0), start(0) {/* Optional code */}

	// Modification 3:
	// Member unction is const => is not allowed to change object
	bool Empty(void) const
	{
		return (number == 0);
	}

	// Modification 3:
	// Member unction is const => is not allowed to change object
	bool IsElement(double x) const;
	
	bool Insert(double x);
	
	// Modification 3:
	// Member unction is const => is not allowed to change object
	void Content(void) const;

	// Modification 2:
	// Declaration of destructor.
	// Remark: Not void ~DoubSet(void);
	~DoubSet(void);

private:
	int number;
	DoubElem* start;
};

