// stream.cpp
// Michael Madden, Jan 2001
// Demonstrates simple stream input/output

#include <iostream.h>
#include <iomanip.h>

void main()
{
  char c;
  float f;

  cout << "Enter spaces (optional), followed by a character and a number:" << endl;

  // input character and float
  // skip white-space before input
  cin >> ws >> c >> f;

  // set field-width to 5 and precision to 2,
  // and output float
  cout << endl << "Character entered: " << c << endl 
       << "Number entered (2 significant figures): "
       << setw(5) << setprecision(2) << f << endl;
}
