// this.cpp: Example for using explicit reference
// M. Schukat, 2002
 
#include <math.h>
#include <iostream.h>
#include <stdlib.h>

class Example
{
private:
	int i;

public:
	Example(void)
	{
		i = 0;
	}


	int GetVariable(void)
	{
		return i;
	}
	

	void f(int k)
	{
		int i = 10;

		// We have to variables with the same name but different scope:
		//  :- attribute of object t1
		//  :
		//  :         :- local variable i
		//  :         :
		this->i = k * i;
	}
};

int main(void)
{
	Example t1;

	cout << "t1 before call of f(): " << t1.GetVariable() << endl;

	t1.f(5);

	cout << "t1 after  call of f(): " << t1.GetVariable() << endl;

	return 0;
}



